=== added file 'TODO'
--- TODO	1970-01-01 00:00:00 +0000
+++ TODO	2009-07-15 11:44:24 +0000
@@ -0,0 +1,46 @@
+Make a python module for python-debian
+ - function to read the value database
+ - function to open the database read-only
+
+Add a --stop option to stop a running update-apt-xapian-index
+
+- Disabling the update in postinst via a preseedable debconf
+  low-priority question
+
+
+Date the package was last touched (from the "Latest News" section of the QA
+page, e.g.: http://packages.qa.debian.org/g/geomview.html)
+
+Index as a post-hook of dpkg/aptitude/apt/whatever the first installation date of packages (and also the last upgrade date)
+
+Debstemming: only needed indexing-side, can be done by a plugin and integrated with extra keywords installed by packages in a lintian-override kind of way
+
+
+Downloading extra fluff:
+ - scheduling rate
+ - one pkg per source or kind of source
+
+Three phases:
+ - fetch
+    - get apt to do it, if possible
+ - run integration script
+    - get apt to run them fetcher style, in parallel, if possible
+ - index by update-apt-xapian-index
+    - get it to be done after integration scripts have been run
+
+Reporting status (syntaxes to be reused):
+ - dpkg has --status-fd with some format
+ - apt fetchers report status as well somehow
+
+Source lines in /etc/apt/sources.list
+ - could be added in /etc/apt/sources.list.d if it exists
+ - could be added in postinst, commented out on remove and removed on purge
+   (possibly using patch, or maybe ucf)
+ - could be added as a separate sources.list activated by an apt.conf.d entry
+
+Detecting last install/upgrade time
+ - check what time /var/lib/dpkg/PKGNAME.list gets created
+    - checking its mtime for upgrade
+    - useful for weekly builds
+ - dpkg hooks (like man hooks) if possible to run on every package
+    - useful for incremental updates

=== modified file 'debian/changelog'
--- debian/changelog	2009-07-07 16:28:48 +0000
+++ debian/changelog	2009-07-15 11:44:24 +0000
@@ -1,3 +1,11 @@
+apt-xapian-index (0.22) unstable; urgency=low
+
+  * Applied patch by Michael Vogt. Closes: #536857.
+    - Run the weekly update with nice and ionice
+    - Fix bug in --updates when it is selecting the wrong index
+
+ -- Enrico Zini <enrico@debian.org>  Wed, 15 Jul 2009 11:44:24 +0100
+
 apt-xapian-index (0.21) unstable; urgency=low
 
   * Applied patch from Michael Vogt to implement a --update option that

=== modified file 'debian/cron.weekly'
--- debian/cron.weekly	2009-01-24 10:45:05 +0000
+++ debian/cron.weekly	2009-07-15 11:44:24 +0000
@@ -5,5 +5,5 @@
 # Rebuild the index
 if [ -x $CMD ]
 then
-	$CMD --quiet
+	nice ionice -c3	$CMD --quiet
 fi

=== modified file 'debian/rules'
--- debian/rules	2008-07-31 14:57:32 +0000
+++ debian/rules	2009-07-15 11:44:24 +0000
@@ -4,6 +4,7 @@
 
 RELEASE_VERSION=$(shell head -1 debian/changelog | sed -re 's/[^(]+\(([^)]+)\).+/\1/')
 RELEASE_PACKAGE=apt-xapian-index
+SOURCE_VERSION=$(shell grep ^VERSION= update-apt-xapian-index | sed -re 's/^.+"([^"]+)".*/\1/')
 
 build/apt-xapian-index::
 	help2man --section=8 --no-info ./update-apt-xapian-index > update-apt-xapian-index.8
@@ -20,8 +21,9 @@
 	rm -f update-apt-xapian-index.8
 
 release: clean
-	test -z "`git-ls-files -d -o -m -u -s`" || (echo "There are uncommitted changes"; /bin/false)
-	test -z "`git diff --cached`" || (echo "There are uncommitted changes in the index"; /bin/false)
+	test $(SOURCE_VERSION) == $(RELEASE_VERSION) || (echo "Version in source $(SOURCE_VERSION) is different than version in changelog $(RELEASE_VERSION)" >&2; /bin/false)
+	test -z "`git-ls-files -d -o -m -u -s`" || (echo "There are uncommitted changes" >&2; /bin/false)
+	test -z "`git diff --cached`" || (echo "There are uncommitted changes in the index" >&2; /bin/false)
 	git archive --format=tar --prefix=$(RELEASE_PACKAGE)-$(RELEASE_VERSION)/ master | gzip -9 > ../$(RELEASE_PACKAGE)_$(RELEASE_VERSION).tar.gz
 	dpkg-buildpackage -us -uc -S -I.git
 	rm -f ../$(RELEASE_PACKAGE)_$(RELEASE_VERSION)_source.changes

=== added file 'examples/test-scan.py'
--- examples/test-scan.py	1970-01-01 00:00:00 +0000
+++ examples/test-scan.py	2009-07-15 11:44:24 +0000
@@ -0,0 +1,39 @@
+#!/usr/bin/python
+
+#
+# test-scan - Time how long it takes to rescan the whole db
+#
+# Copyright (C) 2009  Enrico Zini <enrico@debian.org>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+
+from aptxapianindex import *
+from optparse import OptionParser
+import sys
+
+import os
+import xapian
+
+# Access the Xapian index
+db = xapian.WritableDatabase("/var/lib/apt-xapian-index/index.1", xapian.DB_OPEN)
+
+for idx, m in enumerate(db.postlist("")):
+    doc = db.get_document(m.docid)
+    val = doc.get_value(1)
+    doc.add_value(11, "antani")
+    db.replace_document(m.docid, doc)
+
+sys.exit(0)

=== modified file 'update-apt-xapian-index'
--- update-apt-xapian-index	2009-07-07 16:28:48 +0000
+++ update-apt-xapian-index	2009-07-15 11:44:24 +0000
@@ -546,7 +546,7 @@
 from optparse import OptionParser
 import sys
 
-VERSION="0.19"
+VERSION="0.22"
 
 class Parser(OptionParser):
     def __init__(self, *args, **kwargs):
@@ -675,9 +675,17 @@
 
 # update only mode
 if options.update:
-    res = updateIndex(XAPIANDBPATH, addons, progress)
+    index = os.path.join(os.path.abspath(XAPIANDBPATH), "index")
+    if not os.path.exists(index):
+        f=open(index, "w")
+        f.write("auto %s.1" % index)
+        f.close()
+    (dbkind, dbpath) = open(index).readline().split()
+    res = updateIndex(dbpath, addons, progress)
     if not res:
         sys.exit(1)
+    # touch the index to update the timestamp
+    open(XAPIANDBSTAMP, "w").close()
     sys.exit()
 
 # Create a new Xapian index with the content provided by the addons

